//
//  flvlist.js
//  firefox
//
//  Created by Zak on 2008-06-12.
//  Contributor Brian King
//  Contributor Chornous Igor
//  Copyright 2008-2012 Ant.com. All rights reserved.
//

function AntFlvListListener()
{
}

AntFlvListListener.prototype =
{
    videoRequest: null,

    observe: function(subject, topic, data)
    {
        if (topic == "alertclickcallback")
            AntFlvList.download(this.videoRequest);

        /**
         * Clean up the videoRequest object when the notification has gone,
         * otherwise it holds a document reference that leaks
         */
        if (topic == "alertfinished")
            delete this.videoRequest;
    }
};

var AntFlvList =
{
    /**
     * Display the notification popup box
     * @param videoRequest
     */
    notify: function(videoRequest)
    {
        try
        {
            var originTitle = AntLib.safeGet(videoRequest.getOrigin(), "title");
            var videoName = videoRequest.getName();

            var title = AntLang.getFormatString(
                "AntFlvList.NotificationTitle", originTitle);
            var text = AntLang.getFormatString(
                "AntFlvList.NotificationText", videoName);

            var alertsService = AntLib.CCSV(
                "@mozilla.org/alerts-service;1", "nsIAlertsService");

            var flvListener = new AntFlvListListener();
            flvListener.videoRequest = videoRequest;

            alertsService.showAlertNotification(
                "chrome://antbar/skin/logo.png", title, text, true, "", flvListener);
        }
        catch (e)
        {
            AntLib.toLog("Cannot notify videoRequest = " + videoRequest.getUri().spec
                         + " e = " + e.toString());
        }
    },

    /**
     * Download a file
     * @param doNotOpen if true the Firefox download manager won't be opened
     */
    download: function (videoRequest, doNotOpen)
    {
        var self = AntFlvList;
        var downloader = new AntDownloader();
        downloader.downloadFlv(videoRequest, doNotOpen);
    }
};
